import { Inject, Injectable } from '@nestjs/common';
import { ClientProxy } from '@nestjs/microservices';
import { Observable, lastValueFrom } from 'rxjs';
import { GEOGRAPHY_SERVICE } from '../ad.di-tokens';
import {
  GeorouterPort,
  RouteRequest,
  RouteResponse,
} from '../core/application/ports/georouter.port';

interface GeorouterService {
  getRoute(request: RouteRequest): Observable<RouteResponse>;
}

@Injectable()
export class Georouter implements GeorouterPort {
  private georouterService: GeorouterService;

  constructor(
    @Inject(GEOGRAPHY_SERVICE) private readonly client: ClientProxy,
  ) {}

  getRoute = async (request: RouteRequest): Promise<RouteResponse> => {
    return lastValueFrom(this.client.send('getRoute', request));
  };
}
